package cn.ibizlab.assetmanagement.core.workorder.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import io.seata.spring.annotation.GlobalTransactional;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.assetmanagement.core.workorder.domain.EAMWOStateModelLine;
import cn.ibizlab.assetmanagement.core.workorder.filter.EAMWOStateModelLineSearchContext;
import cn.ibizlab.assetmanagement.core.workorder.service.IEAMWOStateModelLineService;

import cn.ibizlab.assetmanagement.util.helper.CachedBeanCopier;
import cn.ibizlab.assetmanagement.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.assetmanagement.core.workorder.mapper.EAMWOStateModelLineMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[工单状态模型明细] 服务对象接口实现
 */
@Slf4j
@Service("EAMWOStateModelLineServiceImpl")
public class EAMWOStateModelLineServiceImpl extends ServiceImpl<EAMWOStateModelLineMapper, EAMWOStateModelLine> implements IEAMWOStateModelLineService {

    @Autowired
    @Lazy
    protected cn.ibizlab.assetmanagement.core.workorder.service.IEAMWOStateModelService eamwostatemodelService;
    @Autowired
    @Lazy
    protected cn.ibizlab.assetmanagement.core.workorder.service.IEAMWOStateService eamwostateService;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(EAMWOStateModelLine et) {
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getEamwostatemodellineid()),et);
        return true;
    }

    @Override
    public void createBatch(List<EAMWOStateModelLine> list) {
        this.saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean update(EAMWOStateModelLine et) {
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("eamwostatemodellineid",et.getEamwostatemodellineid())))
            return false;
        CachedBeanCopier.copy(get(et.getEamwostatemodellineid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<EAMWOStateModelLine> list) {
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public EAMWOStateModelLine get(String key) {
        EAMWOStateModelLine et = getById(key);
        if(et==null){
            et=new EAMWOStateModelLine();
            et.setEamwostatemodellineid(key);
        }
        else{
        }
        return et;
    }

    @Override
    public EAMWOStateModelLine getDraft(EAMWOStateModelLine et) {
        return et;
    }

    @Override
    public boolean checkKey(EAMWOStateModelLine et) {
        return (!ObjectUtils.isEmpty(et.getEamwostatemodellineid()))&&(!Objects.isNull(this.getById(et.getEamwostatemodellineid())));
    }
    @Override
    @Transactional
    public boolean save(EAMWOStateModelLine et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(EAMWOStateModelLine et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public boolean saveBatch(Collection<EAMWOStateModelLine> list) {
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    public void saveBatch(List<EAMWOStateModelLine> list) {
        saveOrUpdateBatch(list,batchSize);
    }


	@Override
    public List<EAMWOStateModelLine> selectByEamwostatemodelid(String eamwostatemodelid) {
        return baseMapper.selectByEamwostatemodelid(eamwostatemodelid);
    }

    @Override
    public void removeByEamwostatemodelid(String eamwostatemodelid) {
        this.remove(new QueryWrapper<EAMWOStateModelLine>().eq("eamwostatemodelid",eamwostatemodelid));
    }

	@Override
    public List<EAMWOStateModelLine> selectByEamwostateid(String eamwostateid) {
        return baseMapper.selectByEamwostateid(eamwostateid);
    }

    @Override
    public void removeByEamwostateid(String eamwostateid) {
        this.remove(new QueryWrapper<EAMWOStateModelLine>().eq("eamwostateid",eamwostateid));
    }


    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<EAMWOStateModelLine> searchDefault(EAMWOStateModelLineSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<EAMWOStateModelLine> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<EAMWOStateModelLine>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }







    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<EAMWOStateModelLine> getEamwostatemodellineByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<EAMWOStateModelLine> getEamwostatemodellineByEntities(List<EAMWOStateModelLine> entities) {
        List ids =new ArrayList();
        for(EAMWOStateModelLine entity : entities){
            Serializable id=entity.getEamwostatemodellineid();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0)
           return this.listByIds(ids);
        else
           return entities;
    }

}



